package sexpression;

public class Cons extends SExpression {

    private SExpression car;
    private SExpression cdr;

    public Cons(SExpression car, SExpression cdr) {
        this.car = car;
        this.cdr = cdr;
    }

    public SExpression getCar() {
        return car;
    }

    public SExpression getCdr() {
        return cdr;
    }

    public void setCar(SExpression newCar) {
        car = newCar;
    }

    public void setCdr(SExpression newCdr) {
        cdr = newCdr;
    }

    public boolean consp() {
        return true;
    }

    public String toString() {
        return ("(" + toStringAux());
    }

    // Returns a string representation of the car of a CONS cell followed by
    // its cdr. If the cdr of this CONS cell is not a CONS cell itself, this
    // method places a ')' at the end of its return value. Also, if the cdr of
    // this CONS cell is NIL, it will not be included in the return value of
    // this method. When used in conjunction with the 'toString' method of this
    // class, this method provides a means for creating the correct string
    // representation of a list.
    private String toStringAux() {
        if (cdr.nullp())
            return (car.toString() + ")");
        else if (cdr.consp())
            return (car.toString() + " " + ((Cons) cdr).toStringAux());

        return (car.toString() + " . " + cdr.toString() + ")");
    }

}
